
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Declaration_submissionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const declaration_submissions = await db.declaration_submissions.create(
            {
                id: data.id || undefined,
        
        declaration_type: data.declaration_type
        ||
        null
            ,
            
        submission_reference: data.submission_reference
        ||
        null
            ,
            
        submitted_at: data.submitted_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        response_message: data.response_message
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await declaration_submissions.setMerchant( data.merchant || null, {
            transaction,
        });
        
        await declaration_submissions.setTax_period( data.tax_period || null, {
            transaction,
        });
        
        await declaration_submissions.setSubmitted_by( data.submitted_by || null, {
            transaction,
        });
        
        await declaration_submissions.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.declaration_submissions.getTableName(),
                belongsToColumn: 'submission_payload_file',
                belongsToId: declaration_submissions.id,
            },
            data.submission_payload_file,
            options,
        );
        

        return declaration_submissions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const declaration_submissionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                declaration_type: item.declaration_type
            ||
            null
            ,
            
                submission_reference: item.submission_reference
            ||
            null
            ,
            
                submitted_at: item.submitted_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                response_message: item.response_message
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const declaration_submissions = await db.declaration_submissions.bulkCreate(declaration_submissionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < declaration_submissions.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.declaration_submissions.getTableName(),
                    belongsToColumn: 'submission_payload_file',
                    belongsToId: declaration_submissions[i].id,
                },
                data[i].submission_payload_file,
                options,
            );
        }
        

        return declaration_submissions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const declaration_submissions = await db.declaration_submissions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.declaration_type !== undefined) updatePayload.declaration_type = data.declaration_type;
        
        
        if (data.submission_reference !== undefined) updatePayload.submission_reference = data.submission_reference;
        
        
        if (data.submitted_at !== undefined) updatePayload.submitted_at = data.submitted_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.response_message !== undefined) updatePayload.response_message = data.response_message;
        
        
        updatePayload.updatedById = currentUser.id;

        await declaration_submissions.update(updatePayload, {transaction});

        
        
        if (data.merchant !== undefined) {
            await declaration_submissions.setMerchant(
              
              data.merchant,
              
              { transaction }
            );
        }
        
        if (data.tax_period !== undefined) {
            await declaration_submissions.setTax_period(
              
              data.tax_period,
              
              { transaction }
            );
        }
        
        if (data.submitted_by !== undefined) {
            await declaration_submissions.setSubmitted_by(
              
              data.submitted_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await declaration_submissions.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.declaration_submissions.getTableName(),
                belongsToColumn: 'submission_payload_file',
                belongsToId: declaration_submissions.id,
            },
            data.submission_payload_file,
            options,
        );
        

        return declaration_submissions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const declaration_submissions = await db.declaration_submissions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of declaration_submissions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of declaration_submissions) {
                await record.destroy({transaction});
            }
        });


        return declaration_submissions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const declaration_submissions = await db.declaration_submissions.findByPk(id, options);

        await declaration_submissions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await declaration_submissions.destroy({
            transaction
        });

        return declaration_submissions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const declaration_submissions = await db.declaration_submissions.findOne(
            { where },
            { transaction },
        );

        if (!declaration_submissions) {
            return declaration_submissions;
        }

        const output = declaration_submissions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.merchant = await declaration_submissions.getMerchant({
            transaction
        });
        
        
        output.tax_period = await declaration_submissions.getTax_period({
            transaction
        });
        
        
        output.submitted_by = await declaration_submissions.getSubmitted_by({
            transaction
        });
        
        
        output.submission_payload_file = await declaration_submissions.getSubmission_payload_file({
            transaction
        });
        
        
        output.organizations = await declaration_submissions.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.merchants,
        as: 'merchant',
        
        where: filter.merchant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.merchant.split('|').map(term => Utils.uuid(term)) } },
            {
              business_name: {
                [Op.or]: filter.merchant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tax_periods,
        as: 'tax_period',
        
        where: filter.tax_period ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tax_period.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.tax_period.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'submitted_by',
        
        where: filter.submitted_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.submitted_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.submitted_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'submission_payload_file',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.submission_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'declaration_submissions',
                        'submission_reference',
                        filter.submission_reference,
                    ),
                };
            }
            
            if (filter.response_message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'declaration_submissions',
                        'response_message',
                        filter.response_message,
                    ),
                };
            }
            

            
            

            
            if (filter.submitted_atRange) {
                const [start, end] = filter.submitted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    submitted_at: {
                    ...where.submitted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    submitted_at: {
                    ...where.submitted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.declaration_type) {
                where = {
                    ...where,
                declaration_type: filter.declaration_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.declaration_submissions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'declaration_submissions',
                        'submission_reference',
                        query,
                    ),
                ],
            };
        }

        const records = await db.declaration_submissions.findAll({
            attributes: [ 'id', 'submission_reference' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['submission_reference', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.submission_reference,
        }));
    }

    
};

